// ARMSWDDlg.h : Header-Datei
//

#if !defined(AFX_ARMSWDDLG_H__1D557E53_86A6_419B_A0FD_C2E45F7703F6__INCLUDED_)
#define AFX_ARMSWDDLG_H__1D557E53_86A6_419B_A0FD_C2E45F7703F6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "daten.h"
#include "FTD2XX.h"
#include "USB.h"
#include "RS232.h"

/////////////////////////////////////////////////////////////////////////////
// CARMSWDDlg Dialogfeld

class CARMSWDDlg : public CDialog
{
// Konstruktion
public:
	CARMSWDDlg(CWnd* pParent = NULL);	// Standard-Konstruktor

// Dialogfelddaten
	//{{AFX_DATA(CARMSWDDlg)
	enum { IDD = IDD_ARMSWD_DIALOG };
	CProgressCtrl	m_ctlPDownload;
	CListBox	m_ctlLProgress;
	CString	m_strEFile;
	UINT	m_uiPageAnzahl;
	CString	m_sStatusCRC;
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CARMSWDDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

	CStatusBar		ReportBar;				// statusbar
	CWnd*				pWnd;

	void ShowErrors(CString &str);
	void SetStartButtons(void);
	void ButtonsOn(void);
	void ButtonsOff(void);
	void UpdateSBar(void);
	BOOL DoFlash_I2C(void); 
	BOOL DoFlash_LIN(void);
	void EraseBar(void);
	void ImportHexData(void);
	void FillCRCArray(void);
	unsigned int GetCRC(unsigned int uiPage);
	unsigned int GetLinCRC(void);
	void OnReadPage(void);
	BYTE Check_Status_Byte(unsigned char usIn, unsigned char usTest); 
	unsigned long GeneratePageCS(void);
	void ClearPageCS(void);


// Implementierung
protected:
	HICON m_hIcon;
	

	// Generierte Message-Map-Funktionen
	//{{AFX_MSG(CARMSWDDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnBFile();
	afx_msg void OnBConfig();
	afx_msg void OnStart();
	afx_msg void OnFlash();
	afx_msg void OnRun();
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	afx_msg void OnTest();
	afx_msg void OnBCmdDl();
	afx_msg void OnBSecwriteok();
	afx_msg void OnBStatus();
	afx_msg void OnStartLin();
	afx_msg void OnLinFlash();
	afx_msg void OnBWrongFrame();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // !defined(AFX_ARMSWDDLG_H__1D557E53_86A6_419B_A0FD_C2E45F7703F6__INCLUDED_)
