// Functions for RS232
#include "StdAfx.h"
#include "daten.h"
#include "RS232.h"
#include <time.h>
#include <sys/types.h>
#include <sys/timeb.h>




BOOL RS232_Close()
{

	if(AppData.m_ComOpen)
		CloseHandle(m_ComHandle);

	return TRUE;
}


BOOL RS232_Setup()
{
	if(!AppData.m_ComOpen)
	{

		if ((m_ComHandle=CreateFile(AppData.m_strComPort,GENERIC_READ|GENERIC_WRITE,
			FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL))==
			INVALID_HANDLE_VALUE)
		{

			//MessageBox("COM3 nicht verfgbar","",MB_ICONEXCLAMATION);
			AppData.str_Message = "COM Port not available";
			return FALSE;
		}
		else
		{
			FillMemory(&m_COM_DCB, sizeof(m_COM_DCB),0);
			m_COM_DCB.DCBlength = sizeof(m_COM_DCB);
			BuildCommDCB(AppData.m_strComSet, &m_COM_DCB);

			SetCommState(m_ComHandle,&m_COM_DCB);
			AppData.m_ComOpen = TRUE;
			return TRUE;
		}
	}


	


	else
		return TRUE;
		
}

BOOL RS232_Run_CMD()
{
	
	CString Dummy;
    byte ReturnByte[2];

	DWORD	dwWritten;
	DWORD	dwBytesRead;
	DWORD	dwNow, dwEnd;

	BYTE	TxData[9] = {0x07,0x0E,0x05,0x52,0x00,0x08,0x00,0x00,0xA1};

	
	WriteFile(m_ComHandle,&TxData,9,&dwWritten,NULL);

	dwEnd = GetTickCount();
	dwEnd += 10;
	dwNow	= 0;

	while (dwEnd > dwNow)
		dwNow = GetTickCount();

	ReadFile(m_ComHandle,&ReturnByte,1,&dwBytesRead,NULL);

	if(ReturnByte[0] == 0x06)
	{
		AppData.str_Message = "ARM running ...";
		return TRUE;
	}
	else
	{
		if(ReturnByte[0] == 0x07)
		{
			AppData.str_Message = "No acknowledge for  RUN Command";
			return FALSE;
		}
		else
		{
			AppData.str_Message = "Timeout for RUN Commnad";
			return FALSE;
		}		
	}
	
}

BOOL RS232_Send_Frame(DWORD dwToWrite, BYTE* TxData)
{
	CString str,dummy;

	DWORD	dwWritten;
	DWORD	dwNow, dwEnd;
	DWORD	dwBytesReceived;
	
	byte ReturnByte[2];


	WriteFile(m_ComHandle,&TxData,dwToWrite,&dwWritten,NULL);

	dwEnd = GetTickCount();
	dwEnd += 10;
	dwNow	= 0;

	while (dwEnd > dwNow)
		dwNow = GetTickCount();

	ReadFile(m_ComHandle,&ReturnByte,1,&dwBytesReceived,NULL);

	if(ReturnByte[0] == 0x06)
	{
		AppData.str_Message = "ARM running ...";
		return TRUE;
	}
	else
	{
		if(ReturnByte[0] == 0x07)
		{
			AppData.str_Message = "No acknowledge for  RUN Command";
			return FALSE;
		}
		else
		{
			AppData.str_Message = "Timeout for RUN Commnad";
			return FALSE;
		}		
	}

}