// onfigDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "ARMSWD.h"
#include "onfigDlg.h"
#include "daten.h"
#include <fstream.h>

#include "FTD2XX.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld ConfigDlg 


ConfigDlg::ConfigDlg(CWnd* pParent /*=NULL*/)
	: CDialog(ConfigDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(ConfigDlg)
	m_erase = FALSE;
	m_program = TRUE;
	m_verify = FALSE;
	m_autoclear = FALSE;
	m_strEcBrowser = _T("");
	m_strEcHelpp = _T("");
	m_iRadio_CRC = -1;
	//}}AFX_DATA_INIT
}


void ConfigDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(ConfigDlg)
	DDX_Control(pDX, IDC_CPortCom, m_CPortCom);
	DDX_Check(pDX, IDC_KC_MERASE, m_erase);
	DDX_Check(pDX, IDC_KC_PROGRAM, m_program);
	DDX_Check(pDX, IDC_KC_VERIFY, m_verify);
	DDX_Check(pDX, IDC_KC_AUTOCLEAR, m_autoclear);
	DDX_Text(pDX, IDC_EC_BROWSER, m_strEcBrowser);
	DDX_Text(pDX, IDC_EC_HELPP, m_strEcHelpp);
	DDX_Radio(pDX, IDC_RADIO_USER, m_iRadio_CRC);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(ConfigDlg, CDialog)
	//{{AFX_MSG_MAP(ConfigDlg)
	ON_BN_CLICKED(IDC_BC_BROWSE, OnBcBrowse)
	ON_BN_CLICKED(IDC_BC_HELPP, OnBcHelpp)
	ON_WM_HELPINFO()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten ConfigDlg 
BOOL ConfigDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Zustzliche Initialisierung hier einfgen

	m_erase			= AppData.m_masserase;
	m_program		= AppData.m_program;
	m_verify		= AppData.m_verify;
	m_autoclear		= AppData.m_AutoClear;
	m_strEcBrowser	= AppData.m_strEcBrowser;
	m_strEcHelpp	= AppData.m_strEcHelpp;
	m_iRadio_CRC	= AppData.m_iCRC;

	m_CPortCom.ResetContent();
	m_CPortCom.AddString("None");
	m_CPortCom.AddString("USB");
//	m_CPortCom.AddString("COM");
	m_CPortCom.SetCurSel(AppData.m_PortCom);	// set port from ini file


	if(AppData.m_CPU == 1)
	{
		GetDlgItem(IDC_KC_MERASE)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_KC_PROGRAM)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_KC_VERIFY)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_RAHMEN_FLASH)->ShowWindow(SW_HIDE);
		//m_iRadio_CRC = AppData.m_iCRC;
	}
	else
	{
		//GetDlgItem(IDC_KC_MERASE)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_RADIO_CODDEV)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_RADIO_CRC_VAL)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_RADIO_USER)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_RAHMEN_CRC)->ShowWindow(SW_HIDE);
		//m_iRadio_CRC = AppData.m_iCRC;
	}


	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}


void ConfigDlg::OnOK() 
{
	// TODO: Zustzliche Prfung hier einfgen
	UpdateData(true);
	if(AppData.m_CPU == 0) // 702x
	{
		AppData.m_masserase	= m_erase;
		AppData.m_program	= m_program;
		AppData.m_verify	= m_verify;
		AppData.m_AutoClear = m_autoclear;
		AppData.m_PortCom	= m_CPortCom.GetCurSel();
		AppData.m_IniFile	= TRUE;				// IniFile ok
		//AppData.m_iCRC		= m_iRadio_CRC; 
	}
	else
	{
		AppData.m_masserase	= FALSE;
		AppData.m_program	= 1;
		AppData.m_verify	= 1;
		AppData.m_AutoClear = m_autoclear;
		AppData.m_PortCom	= m_CPortCom.GetCurSel();
		AppData.m_IniFile	= TRUE;				// IniFile ok
		AppData.m_iCRC		= m_iRadio_CRC;
	}



//JH inifile
	AppData.WriteIni();

	CDialog::OnOK();
}

void ConfigDlg::OnCancel() 
{
	// TODO: Zustzlichen Bereinigungscode hier einfgen
	
	CDialog::OnCancel();
}



void ConfigDlg::OnBcBrowse() 
{

	static char	Filter[] = "*.exe |*.exe|All Files|*.*||";
	CFileDialog	FileDialog(TRUE,NULL,NULL,OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,Filter);
	CString		str1;
	int			i1;

	FileDialog.m_ofn.lpstrTitle = "Select Browser";
	i1 = m_strEcBrowser.ReverseFind('\\')+1;
	str1 = m_strEcBrowser.Right(m_strEcBrowser.GetLength()-i1);
	strcpy(FileDialog.m_ofn.lpstrFile,str1);
	str1 = m_strEcBrowser.Left(i1);
	FileDialog.m_ofn.lpstrInitialDir = str1;
	if(FileDialog.DoModal()==IDOK)
	{
		str1 = FileDialog.GetPathName();
		m_strEcBrowser = str1;
		AppData.m_strEcBrowser=m_strEcBrowser;
	}
	UpdateData(FALSE);
	
}

void ConfigDlg::OnBcHelpp() 
{
	static char	Filter[] = "*.html |*.html|All Files|*.*||";
	CFileDialog	FileDialog(TRUE,NULL,NULL,OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,Filter);
	CString		str1;

	FileDialog.m_ofn.lpstrTitle = "Select Help File";
	str1 = "AD_P.html";
	strcpy(FileDialog.m_ofn.lpstrFile,str1);
	FileDialog.m_ofn.lpstrInitialDir = m_strEcHelpp;
	if(FileDialog.DoModal()==IDOK)
	{
		str1 = FileDialog.GetPathName();
		str1 = str1.Left(str1.ReverseFind('\\'));
		m_strEcHelpp = str1;
		AppData.m_strEcHelpp=m_strEcHelpp;
	}
	UpdateData(FALSE);
	
}

BOOL ConfigDlg::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	CString	str1,str2;

	str1 = AppData.m_strEcBrowser;
	str2 = AppData.m_strEcHelpp;
	ShellExecute(m_hWnd,"open",str1,str2+"\\AD_P.html",NULL,SW_SHOW);	
//	return CDialog::OnHelpInfo(pHelpInfo);
	return	1;
}
